#ifndef __THE_MAZE_OF_GALIOUS_2_INTERFACES
#define __THE_MAZE_OF_GALIOUS_2_INTERFACES


/* MOG2 INTERFACE CLASS: */ 

class INTERFACE {
	// The EDITOR classes can access all the MOG2 members
	friend class IVariableWnd;
	friend class IToolsWnd;
	friend class IEditWnd;
	friend class BPlayerConfigDlg;
	friend class GameDebugWindow;
	friend class GameWindow;
	friend class VariableListWnd;

	friend class NetworkMOG2Protocol;
	friend class ActiveMOG2;
	friend class ActiveINTERFACE;
	friend class PLACED_OBJECT;

public:
	INTERFACE(void);
	INTERFACE(char *name,MOG2 *game);
	INTERFACE(char *name,INTERFACE *i);
	INTERFACE(int w,int h,OBJECT **o_p);	/* This constructor automatically generates an interface with a GAMEWINDOW */ 
	~INTERFACE(void);

	bool save(FILE *fp,MOG2 *game);
	bool load(FILE *fp,MOG2 *game);

	bool cmp(char *name);
	bool cmp(INTERFACE *i);

	void draw(SDL_Surface *sfc,int x,int y,int dx,int dy,int stx,int sty,float scale,bool *dplane);

private:
	MOG2 *game;
	char *name;
	List<class VARIABLE> interface_variables;
	int used_object_planes;
	int dx,dy;
	class ActionSCRIPT *interface_action;
	int display_mode;	/* 0 - default  */ 
						/* 1 - centered	*/ 
						/* 2 - scale	*/ 
						/* 3 - scale up	*/ 
						/* 4 - scale down	*/ 
						/* 5 - scroll	*/ 

	/* TILES + INITIAL OBJECTS: */ 
	List<class PLACED_TILE> tiles[MAX_OBJECT_PLANES];
	List<PLACED_OBJECT> objects[MAX_OBJECT_PLANES];

};


#endif
