#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_image.h"
#include "SDL_ttf.h"

#include "List.h"
#include "tiles.h"

#include "auxiliar.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif


extern int surface_flags;

TILE_SOURCE::TILE_SOURCE(void)
{
	fname=0;
	sfc=0;
} /* TILE_SOURCE::TILE_SOURCE */ 


TILE_SOURCE::TILE_SOURCE(char *filename)
{
	SDL_Surface *tmp_sfc;

	fname=new char[strlen(filename)+1];
	strcpy(fname,filename);
	tmp_sfc=IMG_Load(fname);
	sfc=0;

	if (tmp_sfc!=0) {
		sfc = SDL_CreateRGBSurface(surface_flags,tmp_sfc->w,tmp_sfc->h,32,0,0,0,AMASK);
		SDL_SetAlpha(sfc,0,SDL_ALPHA_OPAQUE);
		SDL_BlitSurface(tmp_sfc,0,sfc,0);
		SDL_FreeSurface(tmp_sfc);
	} /* if */ 
} /* TILE_SOURCE::TILE_SOURCE */ 


TILE_SOURCE::~TILE_SOURCE(void)
{
	delete []fname;
	fname=0;
	SDL_FreeSurface(sfc);
} /* TILE_SOURCE::~TILE_SOURCE */ 


bool TILE_SOURCE::save(FILE *fp)
{
	fprintf(fp,"%s\n",fname);

	return true;
} /* TILE_SOURCE::save */ 


bool TILE_SOURCE::load(FILE *fp)
{
	unsigned int i;
	char tmp[256];
	SDL_Surface *tmp_sfc;

	if (1!=fscanf(fp,"%s",tmp)) return false;

	if (fname!=0) delete fname;
	fname=new char[strlen(tmp)+1];
	strcpy(fname,tmp);
	strlwr(fname);
	for(i=0;i<strlen(fname);i++) if (fname[i]=='\\') fname[i]='/';
	tmp_sfc=IMG_Load(fname);
	sfc=0;

	if (tmp_sfc!=0) {
		sfc = SDL_CreateRGBSurface(surface_flags,tmp_sfc->w,tmp_sfc->h,32,0,0,0,AMASK);
		SDL_SetAlpha(sfc,0,SDL_ALPHA_OPAQUE);
		SDL_BlitSurface(tmp_sfc,0,sfc,0);
		SDL_FreeSurface(tmp_sfc);
	} /* if */ 

	return true;
} /* TILE_SOURCE::load */ 


bool TILE_SOURCE::cmp(char *n)
{
	if (strcmp(n,fname)==0) return true;

	return false;
} /* TILE_SOURCE::cmp */ 


bool TILE_SOURCE::cmp(TILE_SOURCE *t)
{
	if (strcmp(t->fname,fname)==0) return true;

	return false;
} /* TILE_SOURCE::cmp */ 



