#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "List.h"
#include "auxiliar.h"

#include "variables.h"
#include "mog2.h"

#include "actionscript.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BStringEdDlg.h"
#include "BIntegerEdDlg.h"
#include "BChoiceDlg.h"
#include "BVChoiceDlg.h"

#include "AVariableWnd.h"
#include "GMapWnd.h"
#include "OTopWnd.h"

#include "ActionScriptWnd.h"
#include "ActionEditorWnd.h"
#include "interfaces.h"

#include "editor.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

extern int SCREEN_X;

AVariableWnd::AVariableWnd(int x,int y,int dx,int dy,EDITOR *e,TTF_Font *font) : BWindow(x,y,dx,dy,font) 
{
	BButton *b;

	editor=e;

	b=new BButton(5,5,90,12,"NEW VARIABLE",1);
	buttons.Add(b);

	b=new BButton(100,5,80,12,"ADD STATE",2);
	buttons.Add(b);
	
	b=new BButton(185,5,80,12,"SUB STATE",3);
	buttons.Add(b);
} /* AVariableWnd::AVariableWnd */ 


AVariableWnd::~AVariableWnd()
{
} /* AVariableWnd::~AVariableWnd */ 


bool AVariableWnd::cycle(int stx,int sty)
{
	BWindow::cycle(stx,sty);

	if (((mouse_button&SDL_BUTTON(3) &&
		  !(old_mouse_button&SDL_BUTTON(3))) ||
		 (mouse_button&SDL_BUTTON(1) &&
		  !(old_mouse_button&SDL_BUTTON(1)))) &&
		local_mouse_x>=old_stx && 
		local_mouse_y>=old_sty &&
		local_mouse_x<old_endx &&
		local_mouse_y<old_endy) {
		List<VARIABLE> l,todelete;
		VARIABLE *v;
		char *tmp2;
		int i;
		int y=25;

		if (editor->game!=0) {
			for(i=0;i<editor->game->n_app_states;i++) {
				tmp2=editor->game->s_app_action[i]->generate_string();
				if (local_mouse_x>=0 && local_mouse_x<100+get_text_width(tmp2,font) &&
					local_mouse_y>=y && local_mouse_y<y+TTF_FontHeight(font)) {
					BActionEditorWnd *dlg=new BActionEditorWnd(30,30,640,480,&editor->game->s_app_action[i],0,0,editor,5,font);
					dlg->Execute();
					delete dlg;
					set_dirty();
				} // if  
				delete []tmp2;
				y+=TTF_FontHeight(font)+2;
			} /* for */ 
		} /* if */ 
		y+=40;
	

		l.Instance(editor->game->application_variables);
		l.Rewind();
		while(l.Iterate(v)) {
			tmp2=v->generate_string();
			if (local_mouse_y>=y && 
				local_mouse_y<=y+TTF_FontHeight(font) &&
				local_mouse_x>=0 &&
				local_mouse_x<=180+get_text_width(tmp2,font)) {

				BStringEdDlg *dlg;
				BVChoiceDlg *dlg2;
				char tmp[128];
				int res=0;
				int x,y;

				dlg2=new BVChoiceDlg(-1,-1,0,0,"Choose action:","Edit name\nInteger value\nString value\nDelete\n",&res,font);
				dlg2->Execute();
				delete dlg2;

				if (res==1) {
					if (v->cmp("screen_x") ||
						v->cmp("screen_y") ||
						v->cmp("fps") ||
						v->cmp("hw_render") ||
						v->cmp("player_plane") ||
						v->cmp("sfx_atenuation_min") ||
						v->cmp("sfx_atenuation_max") ||
						v->cmp("state")) {
						int x,y;

						new_window_coordinates(240,50,&x,&y);
						BChoiceDlg *dlg2=new BChoiceDlg(x,y,240,50,"Cannot rename this variable","Accept",&res,editor->font);
						dlg2->Execute();
						delete dlg2;
					} else {
						strcpy(tmp,v->name);
						new_window_coordinates(320,60,&x,&y);
						dlg=new BStringEdDlg(x,y,320,60,"Enter variable name:",tmp,40," ",font);
						dlg->Execute();
						delete dlg;

						delete []v->name;
						v->name=new char[strlen(tmp)+1];
						strcpy(v->name,tmp);
					} /* if */ 

					set_dirty();
				} /* if */ 
				if (res==2) {
					BIntegerEdDlg *dlg;
					if (v->type!=VALUE_INTEGER) v->ivalue=0;
					v->type=VALUE_INTEGER;
					new_window_coordinates(140,60,&x,&y);
					dlg=new BIntegerEdDlg(x,y,140,60,"Enter initial value:",&v->ivalue,8,font);
					dlg->Execute();
					delete dlg;

					set_dirty();
				} /* if */ 

				if (res==3) {
					BStringEdDlg *dlg;
					if (v->type==VALUE_STRING) strcpy(tmp,v->svalue);
										  else tmp[0]=0;
					v->type=VALUE_STRING;
					new_window_coordinates(int(SCREEN_X*0.8),60,&x,&y);
					dlg=new BStringEdDlg(x,y,int(SCREEN_X*0.8),60,"Enter initial value:",tmp,128,"",font);
					dlg->Execute();
					delete dlg;
					v->set(tmp);

					set_dirty();
				} /* if */ 

				if (res==4) {
					if (v->cmp("screen_x") ||
						v->cmp("screen_y") ||
						v->cmp("fps") ||
						v->cmp("hw_render") ||
						v->cmp("player_plane") ||
						v->cmp("sfx_atenuation_min") ||
						v->cmp("sfx_atenuation_max") ||
						v->cmp("state")) {
						int x,y;

						new_window_coordinates(240,50,&x,&y);
						BChoiceDlg *dlg2=new BChoiceDlg(x,y,240,50,"Cannot delete this variable","Accept",&res,editor->font);
						dlg2->Execute();
						delete dlg2;

					} else {
						todelete.Add(v);
					} /* if */ 

					set_dirty();
				} /* if */ 
			} /* if */ 

			delete []tmp2;

			y+=TTF_FontHeight(font)+2;
		} /* while */ 


		while(!todelete.EmptyP()) {
			VARIABLE *v;
			v=todelete.ExtractIni();
			editor->game->application_variables.DeleteElement(v);
			delete v;
		} /* while */ 

	} /* if */ 

	return true;
} /* AVariableWnd::cycle */ 


void AVariableWnd::contens_size(int *dx,int *dy)
{
	int max_x=0;
	int max_y=0;
	List<VARIABLE> l;
	VARIABLE *v;
	char *tmp;
	int i;
	int y=25;
	
	BWindow::contens_size(dx,dy);
	
	max_x=210;
	max_y=65+(TTF_FontHeight(font)+2)*editor->game->n_app_states+editor->game->application_variables.Length()*(TTF_FontHeight(font)+2);

	if (editor->game!=0) {
		for(i=0;i<editor->game->n_app_states;i++) {
			tmp=editor->game->s_app_action[i]->generate_string();
			if (100+get_text_width(tmp,font)>max_x) max_x=100+get_text_width(tmp,font);
			delete []tmp;
			y+=TTF_FontHeight(font)+2;
		} /* for */ 
	} /* if */ 
	y+=40;
	
	l.Instance(editor->game->application_variables);
	l.Rewind();
	while(l.Iterate(v)) {
		tmp=v->generate_string();
		if (180+get_text_width(tmp,font)>max_x) max_x=180+get_text_width(tmp,font);
		delete []tmp;
	} /* while */ 

	if (max_x>*dx) *dx=max_x;
	if (max_y>*dy) *dy=max_y;
} /* AVariableWnd::contens_size */ 


void AVariableWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	int i;
	int y=25;
	List<VARIABLE> l;
	VARIABLE *v;
	char tmp[80];
	char *tmp2;

	SDL_FillRect(sfc,0,0);

	BWindow::draw_contens(sfc,stx,sty,dx,dy);


	if (editor->game!=0) {
		for(i=0;i<editor->game->n_app_states;i++) {
			sprintf(tmp,"STATE %.2i:",i);
			print_left(tmp,font,255,255,255,sfc,0-stx,y-sty);
			tmp2=editor->game->s_app_action[i]->generate_string();
			print_left(tmp2,font,255,255,255,sfc,100-stx,y-sty);	
			delete []tmp2;
			y+=TTF_FontHeight(font)+2;
		} /* for */ 
	} /* if */ 
	y+=20;

	print_left("APP. VARIABLES:",font,255,255,255,sfc,0-stx,y-sty);
	y+=20;

	l.Instance(editor->game->application_variables);
	l.Rewind();
	while(l.Iterate(v)) {
		print_left(v->name,font,255,255,255,sfc,0-stx,y-sty);
		tmp2=v->generate_string();
		print_left(tmp2,font,255,255,255,sfc,180-stx,y-sty);
		delete []tmp2;
		y+=TTF_FontHeight(font)+2;
	} /* while */ 
} /* AVariableWnd::draw_contens */ 


bool AVariableWnd::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		/* New Variable!!: */ 
		{
			VARIABLE *v;
			List<VARIABLE> l;
			int i=0;
			char tmp[80];
			bool added=false,found;

			do{
				if (i==0) {
					sprintf(tmp,"new_variable");
				} else {
					sprintf(tmp,"new_variable_%i",i);
				} /* if */ 

				l.Instance(editor->game->application_variables);
				l.Rewind();
				found=false;
				while(!found && l.Iterate(v)) {
					if (v->cmp(tmp)) found=true;
				} /* while */ 

				if (!found) {
					v=new VARIABLE(tmp,0);
					editor->game->application_variables.Add(v);
					added=true;
				} /* if */ 

				i++;
			}while(!added);

			set_dirty();
		}
		break;
	case 2:
		{
			int i;
			ActionSCRIPT **tmp;

			tmp=new ActionSCRIPT *[editor->game->n_app_states+1];
			for(i=0;i<editor->game->n_app_states;i++) {
				tmp[i]=editor->game->s_app_action[i];
				editor->game->s_app_action[i]=0;
			} /* for */ 
			tmp[i]=new ActionSCRIPT();
			delete []editor->game->s_app_action;
			editor->game->s_app_action=tmp;
			editor->game->n_app_states++;

			set_dirty();
		}
		break;
	case 3:
		{
			if (editor->game->n_app_states>1) {
				int i;
				ActionSCRIPT **tmp;

				tmp=new ActionSCRIPT *[editor->game->n_app_states-1];
				for(i=0;i<editor->game->n_app_states-1;i++) {
					tmp[i]=editor->game->s_app_action[i];
					editor->game->s_app_action[i]=0;
				} /* for */ 
				delete editor->game->s_app_action[i];
				editor->game->s_app_action[i]=0;
				delete []editor->game->s_app_action;
				editor->game->s_app_action=tmp;
				editor->game->n_app_states--;

				set_dirty();
			} /* if */ 
		}
		break;
	default:
		break;
	} /* switch */ 

	return true;
} /* AVariableWnd::button_pressed */ 
