#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "List.h"
#include "auxiliar.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BIntegerEdDlg.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BIntegerEdDlg::BIntegerEdDlg(int x,int y,int dx,int dy,char *q,int *ei,int ml,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	query=q;
	if ((*ei)>=0) {
		sign=1;
	} else {
		sign=-1;
		*ei=-*ei;
	} /* if */ 
	editing_integer=ei;
	sprintf(editing_string,"%i",*editing_integer);
	maxlength=ml;
} /* BIntegerEdDlg::BIntegerEdDlg */ 


BIntegerEdDlg::~BIntegerEdDlg()
{
} /* BIntegerEdDlg::~BIntegerEdDlg */ 


void BIntegerEdDlg::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BIntegerEdDlg::contens_size */ 


void BIntegerEdDlg::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);
	print_centered(query,font,255,255,255,sfc,sfc->w/2-stx,8-sty);

	r.x=10-stx;
	r.y=(dy-20)-sty;
	r.w=dx-20;
	r.h=12;
	SDL_FillRect(sfc,&r,0);

	if (sign>0) {
		print_left(editing_string,font,255,255,255,sfc,15-stx,(dy-18)-sty);
		print_left("_",font,128,128,255,sfc,15+get_text_width(editing_string,font)-stx,(dy-18)-sty);
	} else {
		print_left("-",font,255,255,255,sfc,15-stx,(dy-18)-sty);
		print_left(editing_string,font,255,255,255,sfc,15-stx+get_text_width("-",font),(dy-18)-sty);
		print_left("_",font,128,128,255,sfc,15+get_text_width(editing_string,font)-stx+get_text_width("-",font),(dy-18)-sty);
	} /* if */ 

} /* BIntegerEdDlg::draw_contens */ 


bool BIntegerEdDlg::event(SDL_Event *event)
{
	if (active_window!=this) return true;

	if (event->type==SDL_KEYDOWN) {
		/* Keyboard event */ 
		if (event->key.keysym.sym==SDLK_BACKSPACE) {
			if (editing_string[0]!=0) editing_string[strlen(editing_string)-1]=0;
		} /* if */ 

		if (event->key.keysym.sym==SDLK_RETURN) {
			*editing_integer=sign*atol(editing_string);
			return false;
		} /* if */ 

		if (event->key.keysym.sym>=SDLK_0 &&
			event->key.keysym.sym<=SDLK_9) {
			editing_string[strlen(editing_string)+1]=0;
			editing_string[strlen(editing_string)]='0'+(event->key.keysym.sym-SDLK_0);
		} /* if */ 

		if (event->key.keysym.sym==SDLK_MINUS || 
			event->key.keysym.sym==SDLK_KP_MINUS || 
			event->key.keysym.sym==SDLK_LESS ||
			event->key.keysym.sym==SDLK_SLASH) {
			sign*=-1;
		} /* if */ 

		editing_string[maxlength]=0;
		dirty=true;
    } /* if */ 

	return true;
} /* BIntegerEdDlg::Event */ 

